Halide 22.0.0 Halide compiler and libraries

Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2 , typename B2 , VectorReduce::Operator reduce_op_2>
HALIDE_ALWAYS_INLINE bool | match (const VectorReduceOp< A2, B2, reduce_op_2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const

## Public Attributes
A | a
B | lanes

## Static Public Attributes
static constexpr uint32_t | binds = bindings<A>::mask | bindings<B>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::VectorReduce
static constexpr IRNodeType | max_node_type = IRNodeType::VectorReduce
static constexpr bool | canonical = A::canonical
static constexpr bool | foldable = false

## Detailed Description

template<typename A, typename B, VectorReduce::Operator reduce_op>
struct Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >

Definition at line 1934 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/2]

template<typename A , typename B , VectorReduce::Operator reduce_op>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1946 of file IRMatch.h.

References Halide::Internal::VectorReduce::_node_type, Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::a, Halide::Expr::get(), Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::lanes, Halide::Type::lanes(), Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match(), Halide::Internal::VectorReduce::op, Halide::Internal::BaseExprNode::type, and Halide::Internal::VectorReduce::value.

Referenced by Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match().

## ◆ match() [2/2]

template<typename A , typename B , VectorReduce::Operator reduce_op>
template<uint32_t bound, typename A2 , typename B2 , VectorReduce::Operator reduce_op_2>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match | ( | const VectorReduceOp< A2, B2, reduce_op_2 > & | op,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1959 of file IRMatch.h.

References Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::a, Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::lanes, Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match(), and Halide::Internal::IRMatcher::unwrap().

## ◆ make()

template<typename A , typename B , VectorReduce::Operator reduce_op>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 1966 of file IRMatch.h.

References Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::a, halide_scalar_value_t::i64, Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::lanes, Halide::Internal::VectorReduce::make(), and halide_scalar_value_t::u.

## Member Data Documentation

## ◆ a

template<typename A , typename B , VectorReduce::Operator reduce_op>

A Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::a

Definition at line 1936 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::make(), Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ lanes

template<typename A , typename B , VectorReduce::Operator reduce_op>

B Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::lanes

Definition at line 1937 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::make(), Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ binds

template<typename A , typename B , VectorReduce::Operator reduce_op>

constexpr uint32_t Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::binds = bindings<A>::mask | bindings<B>::mask
| static constexpr

Definition at line 1939 of file IRMatch.h.

## ◆ min_node_type

template<typename A , typename B , VectorReduce::Operator reduce_op>

constexpr IRNodeType Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::min_node_type = IRNodeType::VectorReduce
| static constexpr

Definition at line 1941 of file IRMatch.h.

## ◆ max_node_type

template<typename A , typename B , VectorReduce::Operator reduce_op>

constexpr IRNodeType Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::max_node_type = IRNodeType::VectorReduce
| static constexpr

Definition at line 1942 of file IRMatch.h.

## ◆ canonical

template<typename A , typename B , VectorReduce::Operator reduce_op>

constexpr bool Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::canonical = A::canonical
| static constexpr

Definition at line 1943 of file IRMatch.h.

## ◆ foldable

template<typename A , typename B , VectorReduce::Operator reduce_op>

constexpr bool Halide::Internal::IRMatcher::VectorReduceOp< A, B, reduce_op >::foldable = false
| static constexpr

Definition at line 1974 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h